<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: core.php,v 1.12 2005/06/28 21:02:09 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


define("BBENGINE", 1);
session_start();
//# Configuration and connection files
require("configuration/config.inc.php");
require("configuration/database.inc.php");
require("engine/functions.inc.php");
require("engine/mysql.class.php");
require("engine/gzip.class.php");
require("engine/user.class.php");
require("engine/timer.class.php");
require("engine/template.class.php");

//# Configure engine
$script['version'] = "1.0.0 Beta 3";
$timer = new Timer();
$SQL = new MySQL($database);
$gzip = new GZip($config['usegz'], $config['gzlevel']);
$user = new User();
$template = new templateEngine();

//# Remove magic quotes if they are on
set_magic_quotes_runtime(0);
if(get_magic_quotes_gpc()){
    function stripslashes_deep($value){
        $value = is_array($value) ? array_map('stripslashes_deep', $value) : stripslashes($value);
        return $value;
    }

    $_POST = array_map('stripslashes_deep', $_POST);
    $_GET = array_map('stripslashes_deep', $_GET);
    $_COOKIE = array_map('stripslashes_deep', $_COOKIE);
}

//# Initialize engine
$timer->startTimer();
$SQL->connect();
$gzip->startGZ();
$user->loadUser();

//# Setting lastvisit cookie
if(!isset($_SESSION['lastvisit'])){
    if(!isset($_COOKIE[$config['ckprefix'].'lastvisit'])){
        $_SESSION['lastvisit'] = time();
    } else {
        $_SESSION['lastvisit'] = $_COOKIE[$config['ckprefix'].'lastvisit'];
    }
}
setcookie($config['ckprefix']."lastvisit", time(), time() + 31536000, $config['cookiepath'], $config['cookiedomain']);

//# Loading templates
if($bb_templates){
    $bb_templates .= ','.$user->getData('navtemp').',12,60';
}
if($config['locked'] == '1' && $user->getData('admin_cp') != 1){
    $bb_templates = '1,10,12';
}

$template->loadTemplates($bb_templates, $user->getData('skin'));

//# Setting $nav template
eval("\$nav = \"".$template->templates[$user->getData('navtemp')]."\";");

//# Starting breadcrumbs
$breadcrumbs = "<a href=\"$config[boardurl]\">$config[boardname]</a>";

if($user->getData('banned') != 0){
    bb_error("This account has been banned by the admin.");
}

if($config['locked'] == '1' && $user->getData('admin_cp') != 1 && (FILEID != 'member' || prepValue($_GET['a']) != 'login')){
    $nav = "<center><b>Locked</b></center>";

    $breadcrumbs = "<a href=\"$config[boardurl]\">$config[boardname]</a>" . $template->getVar('crumbsseperator') . "Locked";
    $cellhead = "<center>Locked</center>";
    $cellmessage = $config['lockedmsg'];
    eval("\$include = \"".$template->templates['12']."\";");
    eval("\$include .= \"<br>".$template->templates['10']."\";");

    //# Setting script vars
    $script['gzstatus'] = $gzip->checkGZText();
    $script['querycount'] = $SQL->counter();
    $script['exectime'] = $timer->stopTimer();

    //# Creating output, sending it to the buffer, and releasing the buffer
    eval("\$output = \"".$template->templates['1']."\";");
    echo stripslashes($output);
    $gzip->stopGZ();
    die();
}

//# PM Checker
if((FILEID != 'usercp') && ($user->getData('notificationifpm') == 1) && ($user->getData('unreadpm') != "")){
    $pm['id'] = $user->getData('unreadpm');
    eval("\$pmcheck = \"".$template->templates['67']."\";");
}
?>