<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: functions.inc.php,v 1.22 2005/06/29 18:51:47 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# Prepares a value for inserting in the DB
function prepValue($value) {
    if(!is_array($value)){
        $value = htmlspecialchars($value, ENT_QUOTES);
        $value = addslashes($value);
        $value = str_replace('$', '&#36;', $value);

        return $value;
    }

    foreach($value as $key => $val){
        $val = htmlspecialchars($val, ENT_QUOTES);
        $val = addslashes($val);
        $value[$key] = $val;
    }
    $value = str_replace('$', '&#36;', $value);

    return $value;
}

//# Parse URLs
function parse_urls($string) {
    global $config;

    $result = preg_replace("#(<br \/>|^| )(".$config['acceptedurlproto']."):\/\/([^, \n\r\<\>]+)#ei", "build_url('\\2://\\3','\\1')", $string);
    $result = preg_replace("#(<br \/>|^| )(www)\.([^, \n\r\<\>]+)#ei", "build_url('http://\\2.\\3','\\1')", $result); // Needs more testing
    return $result;
}

//# Build URL
function build_url($string, $begin = "") {
    if(substr($string, -1) == "."){
        $string = substr($string, 0, -1);
        $extra = ".";
    }
    $result = $begin."<a href=\"".$string."\" target=\"_blank\">".$string."</a>$extra";
    return $result;
}

//# Remove Breaks
function bb_fix($value, $type) {
    $value = stripslashes($value);
    if ($type == 1) {
        global $emoticons, $emoticonimages;
        $value = str_replace($emoticonimages, $emoticons, $value);
        $value = br2nl($value);
    } elseif ($type == 2) {
        $value = br2nl($value);
    } elseif ($type == 3){
        global $emoticons, $emoticonimages;
        $value = str_replace($emoticonimages, $emoticons, $value);
        $value = str_replace(" ", "&nbsp;", $value);
        $value = "Code Block:<br \><div class=\"code\">".$value."</div>";
    }

    $value = addslashes($value);

    return $value;
}

//# Numbered Code
function kewl_php_code($value) {
    global $emoticons, $emoticonimages;
    $value = stripslashes($value);
    $value = str_replace($emoticonimages, $emoticons, $value);
    $value = str_replace('<br />',"\n",$value);
    $value = str_replace('<br>', "\n", $value);
    $value = str_replace('&#36;','$',$value);
    $value = str_replace('&#039;',"'",$value);
    $value = str_replace('&lt;','<',$value);
    $value = str_replace('&gt;','>',$value);
    $value = str_replace('&amp;','&',$value);
    $value = str_replace('&quot;','"',$value);
    $value = highlight_string($value, 1);
    $value = str_replace('<code>','',$value);
    $value = str_replace('</code>','',$value);

    $value = "PHP Code Block:<br \><div class=\"code\">".$value."</div>";
    $value = str_replace('$','&#36;',$value);
    $value = addslashes($value);

    return $value;
}

//# Parse BB Code
function parse_bbcode($value) {
    global $template;
    global $config;

    $patterns[] = "#\[b\](.+?)\[\/b]#im";
    $replacements[] = "<b>\\1</b>";
    $patterns[] = "#\[i\](.+?)\[\/i]#im";
    $replacements[] = "<i>\\1</i>";
    $patterns[] = "#\[u\](.+?)\[\/u]#im";
    $replacements[] = "<u>\\1</u>";
    $patterns[] = "#\[pre\](.+?)\[\/pre]#ime";
    $replacements[] = "'<pre>'.bb_fix('\\1',2).'</pre>'";
    $patterns[] = "#\[left\](.+?)\[\/left]#i";
    $replacements[] = "<div align=\"left\">\\1</div>";
    $patterns[] = "#\[center\](.+?)\[\/center]#i";
    $replacements[] = "<div align=\"center\">\\1</div>";
    $patterns[] = "#\[right\](.+?)\[\/right]#i";
    $replacements[] = "<div align=\"right\">\\1</div>";
    $patterns[] = "#\[justify\](.+?)\[\/justify]#i";
    $replacements[] = "<div align=\"justify\">\\1</div>";
    $patterns[] = "#\[img\](((http|https)://)(.+?))\[\/img]#ime";
    $replacements[] = "'<img src=\"'.bb_fix('\\1',1).'\" border=\"0\" alt=\"User Posted Image\">'";
    $patterns[] = "#\[img=(.+?),(.+?)\](((http|https)://)(.+?))\[\/img]#ime";
    $replacements[] = "'<img src=\"'.bb_fix('\\3',1).'\" width=\"\\1\" height=\"\\2\" border=\"0\" alt=\"User Posted Image\">'";
    $patterns[] = "#\[url\](((".$config['acceptedurlproto'].")://)(.+?))\[\/url]#ie";
    $replacements[] = "'<a href=\"'.bb_fix('\\1',1).'\" target=\"_blank\">\\1</a>'";
    $patterns[] = "#\[email\]([a-z0-9&\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\[\/email]#ie";
    $replacements[] = "'<a href=\"mailto:'.bb_fix('\\1',1).'\" target=\"_blank\">\\1</a>'";
    $patterns[] = "#\[url=(((".$config['acceptedurlproto'].")://)(.+?))\](.+?)\[\/url]#ie";
    $replacements[] = "'<a href=\"'.bb_fix('\\1',1).'\" target=\"_blank\">\\5</a>'";
    $patterns[] = "#\[email=([a-z0-9&\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\](.+?)\[\/email]#ie";
    $replacements[] = "'<a href=\"mailto:'.bb_fix('\\1',1).'\">\\3</a>'";
    $patterns[] = "#\[align=(.+?)\](.+?)\[\/align]#i";
    $replacements[] = "<div align=\"\\1\">\\2</div>";
    $patterns[] = "#\[color=(.+?)\](.+?)\[\/color]#i";
    $replacements[] = "<font color=\"\\1\">\\2</font>";
    $patterns[] = "#\[size=(.+?)\](.+?)\[\/size]#i";
    $replacements[] = "<font size=\"\\1\">\\2</font>";
    $patterns[] = "#\[code\](.+?)\[\/code]#ie";
    $replacements[] = "bb_fix('\\1',3)";
    $patterns[] = "#\[php\](.+?)\[\/php]#ie";
    $replacements[] = "kewl_php_code('\\1')";

    $value = preg_replace($patterns, $replacements, $value);
    if(substr_count($value,"[quote]") + preg_match_all("/\[quote=(.+?)]/", $value, $quote_matches) == substr_count($value,"[/quote]")){
        $qt = explode('$quote', $template->getTemplate('25'));
        $cqt = explode('$quote', str_replace('$caption', '\\1', $template->getTemplate('145')));
        $value = str_replace("[quote]", $qt[0],$value);
        $value = preg_replace("/\[quote=(.+?)]/",$cqt[0], $value);
        $value = str_replace("[/quote]", $qt[1],$value);
    }

    return $value;
}

//# Parse line breaks
function parse_breaks($value) {
    if (strrpos($value, "\r") < strrpos($value, "\n")) {
        $value = str_replace("\r\n","<br />",$value);
        $value = str_replace("\n\r","<br />",$value);
    } else {
        $value = str_replace("\n\r","<br />",$value);
        $value = str_replace("\r\n","<br />",$value);
    }
    $value = str_replace("\n","<br />",$value);
    $value = str_replace("\r","<br />",$value);
    $value= str_replace("\t","&nbsp;&nbsp;&nbsp;&nbsp;",$value);
    return $value;
}

//# Censor bad words using a list
function censor($string) {
    global $config;

    $templist = explode(',',$config['badwordpool']);
    $badwords = array();
    $badwordreplace = array();
    foreach($templist as $key => $value) {
        $chars = strlen($value);
        $badwords[$key] = "/".strtolower($value)."/i";
        for($i = 0; $i < $chars; $i++) {
            $badwordreplace[$key] .= "*";
        }
    }
    $string = preg_replace($badwords, $badwordreplace, $string);

    return $string;
}

//# Does a normal header(), and dies
function die_header($arg) {
    @header($arg);
    die();
}

//# Does a templated error, then dies
function bb_error($error) {
    extract($GLOBALS);

    $breadcrumbs = "<a href=\"$config[boardurl]\">$config[boardname]</a>" . $template->getVar('crumbsseperator') . "Error";
    $cellhead = "<center>Error</center>";
    eval("\$cellmessage = \"".$template->templates['60']."\";");
    eval("\$include = \"".$template->templates['12']."\";");

    //# Setting script vars
    $script['gzstatus'] = $gzip->checkGZText();
    $script['querycount'] = $SQL->counter();
    $script['exectime'] = $timer->stopTimer();
    $executiontime = $timer->getTimer();
    $script['mysqlexectime'] = $SQL->getexectime();
    $script['phpexectime'] = $executiontime - $script['mysqlexectime'];
    $script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
    $script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

    //# Creating output, sending it to the buffer, and releasing the buffer
    eval("\$output = \"".$template->templates['1']."\";");
    echo stripslashes($output);
    $gzip->stopGZ();
    die();
}

//# Parses emoticons
function parse_emoticons($string, $emoticons, $emoticonimages, $number) {
    if ($number > 0) {
        $positions = array();
        foreach($emoticons as $key => $value) {
            $pos = 0;
            $count = substr_count($string, $value);
            for($i = 0; $i < $count; $i++) {
                $pos = strpos(substr($string, $pos), $value) + strlen($value) + $pos;
                $positions[] = $pos;
            }
        }
        sort($positions);
        if ($positions[$number-1] != NULL) {
            $half = str_replace($emoticons, $emoticonimages, substr($string, 0, $positions[$number-1]));
            $string = $half.substr($string, $positions[$number-1]);
        } else {
            $string = str_replace($emoticons, $emoticonimages, $string);
        }
    } else {
        $string = str_replace($emoticons, $emoticonimages, $string);
    }
    return $string;
}

//# Sends a email
function bb_sendmail($to, $subject, $message, $append) {
    global $config;

    if(!function_exists('mail')){
        bb_error("The mail function is not supported on this server.");
    }

    $headers  = "From: ".$config['boardname']." <".$config['mail_from'].">\n";
    $headers .= "To: ".$to."\n";
    $headers .= "X-Mailer: ".$script['version']."\n";
    $headers .= "MIME-Version: 1.0\n";
    $headers .= "Content-Type: text/plain; charset=utf-8\n";
    $headers .= $append;

    if ($config['mail_type'] == 2) {
        if (empty($config['mail_from']) || empty($config['mail_srv_auth']) || empty($config['mail_hostname']) || empty($config['mail_username']) || empty($config['mail_password'])) {
            bb_error("Email settings are not properly set. Please contact the admin to set all '<b>mail_*</b>' variables in their AdminCP before proceeding.");
        }
        bb_error("SMTP is not currently supported. Variables are a placeholder for the implemmentation");
    } elseif ($config['mail_type'] == 1) {
        if (empty($config['mail_from'])) {
            bb_error("Email settings are not properly set. Please contact the admin to set '<b>mail_from</b>' on their AdminCP");
        }

        if (@mail($to, $subject, $message, $headers) === false) {
            bb_error("There was an error with the mail() function. Please try again.<br>If This continues, contact the administrator");
        }
    } else {
        bb_error("The admin is using a email system type that is incorrect or unsupported, please contact the admin and ask that the problem be corrected");
    }
}

//# Convert <br /> to \n (newlines)
function br2nl($string) {
    return str_replace("\r\n", "\n", str_replace("<br />", "\n", $string));
}

//# Format filesize from bytes
function filesize_format($bytes = "") {
    if ($bytes >= 1048576) {
        $retval = (round($bytes / 1048576 * 100) / 100)."MB";
    } else if ($bytes  >= 1024) {
        $retval = (round($bytes / 1024 * 100) / 100)."KB";
    } else {
        $retval = $bytes." Bytes";
    }
    return $retval;
}
?>