<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: gzip.class.php,v 1.4 2005/06/10 02:02:41 mokkan Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


class GZip {
    var $enabled;
    var $level;

    //# Initialized the gzip class
    function GZip($gzenabled, $gzlevel){
        if($gzenabled == 1){
            $this->enabled = $gzenabled;
            $this->level = $gzlevel;
        }
    }

    //# Start Gzip buffering
    function startGZ() {
        if($this->enabled == 1){
            ob_start();
            ob_implicit_flush(0);
        }
    }

    //# Stop Gzip buffering
    function stopGZ() {
        if($this->enabled == 1){
            if ($encoding = $this->checkCanGZ()) {
                $contents = ob_get_contents();
                ob_end_clean();
                @header("Content-encoding: ".$encoding);
                $contents = gzencode($contents, $this->level);
                print($contents);
                exit();
            } else {
                ob_end_flush();
                exit();
            }
        }
    }

    //# Checks if user can use Gzip
    function checkCanGZ(){
        if($this->enabled == 1){
            return 0;
        }
        if(headers_sent()){
            return 0;
        } else {
            if(strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'x-gzip') != false){
                return "x-gzip";
            } elseif(strpos($_SERVER['HTTP_ACCEPT_ENCODING'],'gzip') != false){
                return "gzip";
            } else {
                return 0;
            }
        }

    }

    //# Checks if Gzip is enabled and returns text
    function checkGZText(){
        if ($this->enabled == 1) {
            return "Enabled";
        } else {
            return "Disabled";
        }
    }

    //# Checks if Gzip is enabled
    function checkGZ(){
        if ($this->enabled == 1) {
            return true;
        } else {
            return false;
        }
    }
}
?>