<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: template.class.php,v 1.5 2005/06/10 02:02:41 mokkan Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


class templateEngine {
    var $cache;
    var $cacheCounter;
    var $templates;
    var $tempvars;
    var $varlist_keys;
    var $varlist_values;
    
    //# Loads the templates specified in the template string, from the specified skin
    function loadTemplates($string, $skin){
        global $SQL, $config, $database;
        $string = str_replace(" ", "", $string);
        $string = str_replace("\n", "", $string);
        $string = str_replace("\r", "", $string);
        $string = str_replace("\t", "", $string);
        $string = str_replace(',', "','", $string);
        
        $grabtempvars = $SQL->query("SELECT * FROM `".$database['prefix']."tempvars` WHERE `skinid` = '$skin' AND `scope` = 'global' OR (`templateid` IN('$string'))");
        $varcounter = 0;
        while($variable = $SQL->fetch_array($grabtempvars)){
            $this->varlist_keys[$varcounter] = '$tempvars['.$variable['id'].']';
            $this->varlist_values[$varcounter] = $variable['value'];
            $this->tempvars[$variable['id']] = $variable['value'];
            $varcounter++;
        }

        $grabtemplates = $SQL->query("SELECT * FROM `".$database['prefix']."templates` WHERE `skinid`='$skin' AND (`id` IN('$string'))");
        while($template = $SQL->fetch_array($grabtemplates)){
            $this->templates[$template['id']] = str_replace($this->varlist_keys, $this->varlist_values, $template['template']);
        }
        
        if($SQL->num_rows($grabtemplates) < 1){
            return false;
        } else {
            return true;
        }
    }
    
    //# Caches array for later use in the templates
    function cacheArray($buffer, $array, $name = "default", $symbol = "number"){
        if($array == NULL){
            return NULL;
        }
        if($this->cache[$name]){
            $this->cacheCounter[$name]++;
            foreach($array as $key => $value){
                $this->cache[$name][$key.$this->cacheCounter[$name]] = $value;
            }
            $buffer = str_replace('$'.$symbol, $this->cacheCounter[$name], $buffer);
        } else {
            $this->cacheCounter[$name] = 0;
            foreach($array as $key => $value){
                $this->cache[$name][$key.$this->cacheCounter[$name]] = $value;
            }
            $buffer = str_replace('$'.$symbol, $this->cacheCounter[$name], $buffer);
        }
        return $buffer;
    }
    
    //# Releases the specified cache
    function releaseCache($name = "default", $delete = true){
        $return = $this->cache[$name];
        if($delete == true){
            unset($this->cache[$name]);
            unset($this->cacheCounter[$name]);
        }
        return $return;
    }
    
    //# Returns a raw template
    function getTemplate($id){
        return $this->templates[$id];
    }
    
    //# Returns a raw tempvar
    function getVar($id){
        return $this->tempvars[$id];
    }
    
    //# Removes cache symbols from template, and returns it
    function cleanTemplate($id, $symbol = "number"){
        return str_replace('$'.$symbol, '', $this->templates[$id]);;
    }

    //# Parses tempvars in the specifed string
    function parseTempvars($string){
        return str_replace($this->varlist_keys, $this->varlist_values, $string);
    }
}
?>