<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: install.php,v 1.32 2005/06/30 02:51:57 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/

$install_version = "1.0.0 Beta 3";

//# Remove magic quotes if they are on
set_magic_quotes_runtime(0);
if(get_magic_quotes_gpc()){
    function stripslashes_deep($value){
        $value = is_array($value) ? array_map('stripslashes_deep', $value) : stripslashes($value);
        return $value;
    }

    $_POST = array_map('stripslashes_deep', $_POST);
    $_GET = array_map('stripslashes_deep', $_GET);
    $_COOKIE = array_map('stripslashes_deep', $_COOKIE);
}

require("engine/timer.class.php");
$timer = new Timer();
$timer->startTimer();

//# Lock password
if(file_exists('configuration/install.lock')){
    $location = "locked";
    $include = "<center><br><br><b>Error:</b> The install file is currently locked. Please delete the install.lock file to run install.<br><br><br></center>";
} else {
    require("engine/mysql.class.php");
    require("engine/functions.inc.php");

    $step = prepValue($_GET['step']);

    switch($step){
        case '':
           $location = "Step 1 - install type";

            if(!is_dir('images/avatars/')){
                @mkdir('images/avatars/', 0777);
            }
            if(!is_dir('temp/')){
                @mkdir('temp/', 0777);
            }

            $include = '<center><b>Make sure the following directories have read/write access (chmod 666 or 777):</b></center>
                       <table width="68%" align="center" border="0">
                        <tr>
                         <td>
                          <ul><li>./temp*</li>
                          <li>./configuration</li>
                          <li>./images/avatars*</li>
                          <li>./images/emoticons</li>
                          <li>./images/posticons</li>
                          <li>./images/skins/default (or whatever your skin directory is)</li></ul>
                          <font size="1"><i>* May not exist by default</i></font>
                         </td>
                        </tr>
                       </table><br>
                       <center><b>Clean Install:</b> Performs clean install of BirdBoard v'.$install_version.'.<br>
                       <form style="display: inline;"><input type="submit" value="Clean Install"><input type="hidden" name="step" value="clean2"></form>
                       <br><br><b>Upgrade Install:</b> Upgrades installed version of BirdBoard to v'.$install_version.'.<br>
                       <form style="display: inline;"><input type="submit" value="Upgrade Install"><input type="hidden" name="step" value="upgrade2"></form>
                       </center>';
        break;
        case 'clean2':
            $failcount = 0;
            $location = "Install: step 2 - system check";

            if(version_compare(phpversion(), '4.3.0', '>=') == 1){
                $test['phpversion'] = '<span class="passed">Passed</span>';
            } else {
                $test['phpversion'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            @touch('configuration/config.inc.php');
            if(is_writable('configuration/config.inc.php')){
                $test['writeconfig'] = '<span class="passed">Passed</span>';
            } else {
                $test['writeconfig'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            @touch('configuration/database.inc.php');
            if(is_writable('configuration/database.inc.php')){
                $test['writedatabase'] = '<span class="passed">Passed</span>';
            } else {
                $test['writedatabase'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('configuration')){
                $test['writecfgdir'] = '<span class="passed">Passed</span>';
            } else {
                $test['writecfgdir'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('images/emoticons')){
                $test['writeemots'] = '<span class="passed">Passed</span>';
            } else {
                $test['writeemots'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('images/posticons')){
                $test['writeposts'] = '<span class="passed">Passed</span>';
            } else {
                $test['writeposts'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('images/skins/default')){
                $test['writeskins'] = '<span class="passed">Passed</span>';
            }else{
                $test['writeskins'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('temp')){
                $test['writetemp'] = '<span class="passed">Passed</span>';
            }else{
                $test['writetemp'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('images/avatars')){
                $test['writeavatars'] = '<span class="passed">Passed</span>';
            }else{
                $test['writeavatars'] = '<span class="failed">Failed</span>';
                $failcount++;
            }

            if($failcount > 0){
                $bottom = 'A total of <b>'.$failcount.'</b> tests failed. Cannot proceed.';
            } else {
                $bottom = '<form style="display: inline;" action="install.php" method="get"><input type="submit" value="Continue &raquo;"><input type="hidden" name="step" value="clean3"></form>';
            }
            $include = '<table width="60%" align="center" border="0">
                         <tr>
                          <td><b>PHP version at least than 4.3.0</b></td>
                          <td align="right">['.$test['phpversion'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to config.inc.php</b></td>
                          <td align="right">['.$test['writeconfig'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to database.inc.php</b></td>
                          <td align="right">['.$test['writedatabase'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to configuration dir</b></td>
                          <td align="right">['.$test['writedatabase'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to emoticon dir</b></td>
                          <td align="right">['.$test['writeemots'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to posticon dir</b></td>
                          <td align="right">['.$test['writeposts'].']</td>
                         </tr>
                         <tr>
                         <tr>
                          <td><b>Can write to avatar dir</b></td>
                          <td align="right">['.$test['writeavatars'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to temp dir</b></td>
                          <td align="right">['.$test['writetemp'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to skin dir(s)</b></td>
                          <td align="right">['.$test['writeskins'].']</td>
                         </tr>
                         <tr>
                          <td colspan="2" align="center">'.$bottom.'</td>
                         </tr>
                        </table>';
        break;
        case 'clean3':
            $location = "Install: step 3 - database info";
            $include = '<form action="install.php?step=clean4" method="post"><table width="40%" cellpadding="2" cellspacing="1" align="center" border="0">
                         <tr>
                          <td><b>Host:</b></td>
                          <td align="right"><input type="text" size="30" name="hostname" value="localhost"></td>
                         </tr>
                         <tr>
                          <td><b>Username:</b></td>
                          <td align="right"><input type="text" size="30" name="username"></td>
                         </tr>
                         <tr>
                          <td><b>Password:</b></td>
                          <td align="right"><input type="password" size="30" name="password"></td>
                         </tr>
                         <tr>
                          <td><b>Database Name:</b></td>
                          <td align="right"><input type="text" size="30" name="database"></td>
                         </tr>
                         <tr>
                          <td><b>Database Prefix:</b></td>
                          <td align="right"><input type="text" size="30" name="prefix" value="bb_"></td>
                         </tr>
                         <tr>
                          <td align="center" colspan="2"><input type="submit" value="Continue &raquo;"></td>
                         </tr>
                        </table></form>';
        break;
        case 'clean4':
            $location = "Install: step 4 - configuring connection";
            $failcount = 0;
            $password = $_POST['password'];
            $_POST = prepValue($_POST);

            if(!($fp = fopen('configuration/database.inc.php', 'w'))){
                $check['writedbfile'] = '<span class="failed">Failed</span>';
                $check['connect'] = '<span class="failed">Failed</span>';
                $failcount+=2;
            } else {
                fwrite($fp, "<?php\r\n");
                fwrite($fp, "\$database = array(\"hostname\" => \"".$_POST['hostname']."\",\r\n");
                fwrite($fp, "                  \"username\" => \"".$_POST['username']."\",\r\n");
                fwrite($fp, "                  \"password\" => \"".$password."\",\r\n");
                fwrite($fp, "                  \"database\" => \"".$_POST['database']."\",\r\n");
                fwrite($fp, "                  \"prefix\"   => \"".$_POST['prefix']."\",\r\n");
                fwrite($fp, "                  \"pconnect\" => false\r\n");
                fwrite($fp, ");\r\n");
                fwrite($fp, "?>");
                fclose($fp);
                $check['writedbfile'] = '<span class="passed">Success</span>';

                require('configuration/database.inc.php');
                $SQL = new MySQL($database);

                if($SQL->connect() == false){
                    $check['connect'] = '<span class="failed">Failed</span>';
                    $failcount++;
                } else {
                    $check['connect'] = '<span class="passed">Success</span>';
                }
            }
            if($failcount > 0){
                $bottom = 'Failed a total of <b>'.$failcount.'</b> times. Cannot proceed.';
            } else {
                $bottom = '<form style="display: inline;" action="install.php" method="get"><input type="submit" value="Continue &raquo;"><input type="hidden" name="step" value="clean5"></form>';
            }
            $include = '<table width="60%" align="center" border="0">
                         <tr>
                          <td><b>Writing database file</b></td>
                          <td align="right">'.$check['writedbfile'].'</td>
                         </tr>
                         <tr>
                          <td><b>Testing database connection</b></td>
                          <td align="right">'.$check['connect'].'</td>
                         </tr>
                         <tr>
                          <td align="center" colspan="2">'.$bottom.'</td>
                         </tr>
                        </table>';
        break;
        case 'clean5':
            require('configuration/database.inc.php');

            $bb_tables = array('active', 'attachments', 'boardstats', 'emoticons',
                               'forums', 'permissions', 'pmessages', 'polloptions',
                               'polls', 'pollvotes', 'posticons', 'posts', 'skins',
                               'subscriptions', 'templates', 'tempvars', 'usergroups',
                               'topics', 'userranks', 'users');

            $location = "Install: step 5 - constructing database";
            $failcount = 0;
            $SQL = new MySQL($database);
            $SQL->connect();
            foreach($bb_tables as $table){
                if(!($delete = $SQL->query("DROP TABLE IF EXISTS ".$database['prefix'].$table.";", true))){
                    $check['flushdb'] = '<span class="failed">Failed</span>';
                    $failcount++;
                    break;
                }
                $check['flushdb'] = '<span class="passed">Success</span>';
            }

            $fp = fopen("configuration/install.sql", "rb");
            $data = fread($fp, filesize("configuration/install.sql"));
            fclose($fp);

            $tmpdata = $data;
            if(!($data = unserialize($data))){
                $data = $tmpdata;
                $data = str_replace("\n", "\\n", $data);
                $data = str_replace("\r", "\\r", $data);
                $data = unserialize($data);
            }
            $filldb = $data[0];

            foreach($bb_tables as $table){
                $createq = str_replace('%prefix%', $database['prefix'], $filldb['bb_'.$table]['create']);
                if(!($run = $SQL->query($createq, true))){
                    $check['filldb'] = '<span class="failed">Failed</span>';
                    $failcount++;
                    break;
                }

                if(is_array($filldb['bb_'.$table]['queries'])){
                    foreach($filldb['bb_'.$table]['queries'] as $query){
                        $query = str_replace('%prefix%', $database['prefix'], $query);
                        if(!($run = $SQL->query($query, true))){
                            $check['filldb'] = '<span class="failed">Failed</span>';
                            $failcount++;
                            break;
                        }
                    }
                }
                $check['filldb'] = '<span class="passed">Success</span>';
            }
            if($failcount > 0){
                $bottom = 'Failed a total of <b>'.$failcount.'</b> times. Cannot proceed.';
            } else {
                $bottom = '<form style="display: inline;" action="install.php" method="get"><input type="submit" value="Continue &raquo;"><input type="hidden" name="step" value="clean6"></form>';
            }
            $include = '<table width="60%" align="center" border="0">
                         <tr>
                          <td><b>Delete existing BirdBoard tables</b></td>
                          <td align="right">'.$check['flushdb'].'</td>
                         </tr>
                         <tr>
                          <td><b>Fill database with new data</b></td>
                          <td align="right">'.$check['filldb'].'</td>
                         </tr>
                         <tr>
                          <td align="center" colspan="2">'.$bottom.'</td>
                         </tr>
                        </table>';
        break;
        case 'clean6':
            $location = "Install: step6 - board/admin info";
            $path = str_replace("/install.php", "", $_SERVER['SCRIPT_NAME']);
            $url = "http://".$_SERVER['HTTP_HOST'].$path."/";
            $include = '<form action="install.php?step=clean7" method="post"><table width="40%" cellpadding="2" cellspacing="1" align="center" border="0">
                         <tr>
                          <td align="center" colspan="2"><b>Board Info</b></td>
                         </tr>
                         <tr>
                          <td><b>Board Name:</b></td>
                          <td align="right"><input type="text" size="30" name="boardname"></td>
                         </tr>
                         <tr>
                          <td><b>Board URL:</b></td>
                          <td align="right"><input type="text" size="30" name="boardurl" value="'.$url.'"></td>
                         </tr>
                         <tr>
                          <td><b>Cookie Prefix:</b></td>
                          <td align="right"><input type="text" size="30" name="cookieprefix" value="bb_"></td>
                         </tr>
                         <tr>
                          <td><b>Cookie Path:</b></td>
                          <td align="right"><input type="text" size="30" name="cookiepath" value="'.$path.'"></td>
                         </tr>
                         <tr>
                          <td><b>Cookie Domain:</b></td>
                          <td align="right"><input type="text" size="30" name="cookiedomain"></td>
                         </tr>
                         <tr>
                          <td align="center" colspan="2"><b>Admin Info</b></td>
                         </tr>
                         <tr>
                          <td><b>Username:</b></td>
                          <td align="right"><input type="text" size="30" name="username"></td>
                         </tr>
                         <tr>
                          <td><b>Password:</b></td>
                          <td align="right"><input type="password" size="30" name="password"></td>
                         </tr>
                         <tr>
                          <td><b>Comfirm Password:</b></td>
                          <td align="right"><input type="password" size="30" name="password2"></td>
                         </tr>
                         <tr>
                          <td><b>Email Address:</b></td>
                          <td align="right"><input type="text" size="30" name="email"></td>
                         </tr>
                         <tr>
                          <td align="center" colspan="2"><input type="submit" value="Continue &raquo;"></td>
                         </tr>
                        </table></form>';
        break;
        case 'clean7':
            require('configuration/database.inc.php');

            $location = "Install: step 7 - configuring board";

            $pass1 = $_POST['password'];
            $pass2 = $_POST['password2'];
            $_POST = prepValue($_POST);
            $failcount = 0;

            $SQL = new MySQL($database);
            $SQL->connect();

            $fp = fopen("configuration/install.sql", "rb");
            $data = fread($fp, filesize("configuration/install.sql"));
            fclose($fp);

            $tmpdata = $data;
            if(!($data = unserialize($data))){
                $data = $tmpdata;
                $data = str_replace("\n", "\\n", $data);
                $data = str_replace("\r", "\\r", $data);
                $data = unserialize($data);
            }
            $filldb = $data[0];

            $config = $data[2];
            $lastval = $data[3];

            if(!($fp = fopen('configuration/config.inc.php', 'w'))){
                $check['config'] = '<span class="failed">Failed</span>';
                $failcount++;
            } else {
                fwrite($fp, "<?php\r\n");
                fwrite($fp, "\$config = array(\r\n");
                foreach($config as $key => $value){
                    $value = str_replace("\'", "'", $value);
                    $value = addslashes($value);
                    $value = str_replace("\n", "\\n", $value);
                    $value = str_replace("\r", "\\r", $value);

                    if(strcasecmp($key, "boardname") == 0){
                        fwrite($fp, "                \"boardname\"        => \"".$_POST['boardname']."\",\r\n");
                    }else if(strcasecmp($key, "boardurl") == 0){
                        fwrite($fp, "                \"boardurl\"         => \"".$_POST['boardurl']."\",\r\n");
                    }else if(strcasecmp($key, "ckprefix") == 0){
                        fwrite($fp, "                \"ckprefix\"         => \"".$_POST['cookieprefix']."\",\r\n");
                    }else if(strcasecmp($key, "cookiepath") == 0){
                        fwrite($fp, "                \"cookiepath\"       => \"".$_POST['cookiepath']."\",\r\n");
                    }else if(strcasecmp($key, "cookiedomain") == 0){
                        fwrite($fp, "                \"cookiedomain\"     => \"".$_POST['cookiedomain']."\",\r\n");
                    }else if(strcasecmp($key, "mail_from") == 0){
                        fwrite($fp, "                \"mail_from\"        => \"".$_POST['email']."\",\r\n");
                    }else if(strcasecmp($key, $lastval) == 0){
                        $spaces = str_repeat(" ", 17-strlen($key));
                        if(is_numeric($value)){
                            fwrite($fp, "                \"$key\"$spaces=> $value\r\n");
                        }else{
                            fwrite($fp, "                \"$key\"$spaces=> \"$value\"\r\n");
                        }
                    }else{
                        $spaces = str_repeat(" ", 17-strlen($key));
                        if(is_numeric($value)){
                            fwrite($fp, "                \"$key\"$spaces=> $value,\r\n");
                        }else{
                            fwrite($fp, "                \"$key\"$spaces=> \"$value\",\r\n");
                        }
                    }
                }
                fwrite($fp, ");\r\n");
                fwrite($fp, "?>");
                fclose($fp);

                $check['config'] = '<span class="passed">Success</span>';
            }
            require('configuration/config.inc.php');

            if($pass1 != $pass2){
                $include = '<center>The passwords you entered did not match.<br>
                            [<a href="#" onClick="history.go(-1);return true;">Back</a>]';
                break;
            }

            if(!($run = $SQL->query("INSERT INTO `".$database['prefix']."users` (`id`,`gid`,`skin`,`username`,`password`,`email`,`joindate`,`parseurls`,`viewsiggies`,`viewavatars`,`viewhistory`,`subscribe`,`emailifpm`,`notificationifpm`,`hideemail`,`censor`,`disableemoticons`,`posts`,`active`,`postsperpage`,`topicsperpage`,`membersperpage`) VALUES ('','4','".$config['skindefault']."','".$_POST['username']."','".md5($pass1)."','".$_POST['email']."','".time()."','".$config['parseurls']."','".$config['viewsiggies']."','".$config['viewavatars']."','".$config['viewhistory']."','0','1','1','0','".$config['censor']."','".$config['disableemoticons']."','0','1','".$config['postsperpage']."','".$config['topicsperpage']."','".$config['membersperpage']."')", true))){
                $check['admin'] = '<span class="failed">Failed</span>';
                $failcount++;
            } else {
                $check['admin'] = '<span class="passed">Success</span>';
            }

            if(!($statsq = $SQL->query("INSERT INTO `".$database['prefix']."boardstats` (`members`, `posts`, `topics`, `newestuid`, `newestuser`, `mostonline`, `mostonlinedate`) VALUES ('1', '0', '0', '1', '".$_POST['username']."', '0', '0')"))){
                $check['stats'] = '<span class="failed">Failed</span>';
            } else {
                $check['stats'] = '<span class="passed">Success</span>';
            }

            if($failcount > 0){
                $bottom = 'Failed a total of <b>'.$failcount.'</b> times. Cannot proceed.';
            } else {
                $bottom = '<form style="display: inline;" action="install.php" method="get"><input type="submit" value="Continue &raquo;"><input type="hidden" name="step" value="complete"></form>';
            }
            $include = '<table width="60%" align="center" border="0">
                         <tr>
                          <td><b>Write config.inc.php</b></td>
                          <td align="right">'.$check['config'].'</td>
                         </tr>
                         <tr>
                          <td><b>Add administrator</b></td>
                          <td align="right">'.$check['admin'].'</td>
                         </tr>
                         <tr>
                          <td><b>Filling initial stats</b></td>
                          <td align="right">'.$check['stats'].'</td>
                         </tr>
                         <tr>
                          <td align="center" colspan="2">'.$bottom.'</td>
                         </tr>
                        </table>';
        break;
        case 'upgrade2':
            $failcount = 0;
            $location = "Update: step 2 - system check";

            require('configuration/database.inc.php');
            $SQL = new MySQL($database);
            $SQL->connect();

            if(phpversion() >= '4.3.0'){
                $test['phpversion'] = '<span class="passed">Passed</span>';
            } else {
                $test['phpversion'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            @touch('configuration/config.inc.php');
            if(is_writable('configuration/config.inc.php')){
                $test['writeconfig'] = '<span class="passed">Passed</span>';
            } else {
                $test['writeconfig'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            @touch('configuration/database.inc.php');
            if(is_writable('configuration/database.inc.php')){
                $test['writedatabase'] = '<span class="passed">Passed</span>';
            } else {
                $test['writedatabase'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('configuration')){
                $test['writecfgdir'] = '<span class="passed">Passed</span>';
            } else {
                $test['writecfgdir'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('images/emoticons')){
                $test['writeemots'] = '<span class="passed">Passed</span>';
            } else {
                $test['writeemots'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('images/posticons')){
                $test['writeposts'] = '<span class="passed">Passed</span>';
            } else {
                $test['writeposts'] = '<span class="failed">Failed</span>';
                $failcount++;
            }

            $skindirq = $SQL->query("SELECT `value` FROM `".$database['prefix']."tempvars` WHERE `id`='imagepath'");
            $skindir = $SQL->fetch_array($skindirq);

            if(is_writable($skindir['value'])){
                $test['writeskins'] = '<span class="passed">Passed</span>';
            }else{
                $test['writeskins'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('temp')){
                $test['writetemp'] = '<span class="passed">Passed</span>';
            }else{
                $test['writetemp'] = '<span class="failed">Failed</span>';
                $failcount++;
            }
            if(is_writable('images/avatars')){
                $test['writeavatars'] = '<span class="passed">Passed</span>';
            }else{
                $test['writeavatars'] = '<span class="failed">Failed</span>';
                $failcount++;
            }

            if($failcount > 0){
                $bottom = 'A total of <b>'.$failcount.'</b> tests failed. Cannot proceed.';
            } else {
                $bottom = '<form style="display: inline;" action="install.php" method="get"><input type="submit" value="Continue &raquo;"><input type="hidden" name="step" value="upgrade3"></form>';
            }
            $include = '<table width="60%" align="center" border="0">
                         <tr>
                          <td><b>PHP version at least than 4.3.0</b></td>
                          <td align="right">['.$test['phpversion'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to config.inc.php</b></td>
                          <td align="right">['.$test['writeconfig'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to database.inc.php</b></td>
                          <td align="right">['.$test['writedatabase'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to configuration dir</b></td>
                          <td align="right">['.$test['writedatabase'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to emoticon dir</b></td>
                          <td align="right">['.$test['writeemots'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to posticon dir</b></td>
                          <td align="right">['.$test['writeposts'].']</td>
                         </tr>
                         <tr>
                         <tr>
                          <td><b>Can write to avatar dir</b></td>
                          <td align="right">['.$test['writeavatars'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to temp dir</b></td>
                          <td align="right">['.$test['writetemp'].']</td>
                         </tr>
                         <tr>
                          <td><b>Can write to skin dir(s)</b></td>
                          <td align="right">['.$test['writeskins'].']</td>
                         </tr>
                         <tr>
                          <td colspan="2" align="center">'.$bottom.'</td>
                         </tr>
                        </table>';
        break;
        case 'upgrade3':
            $location = "Update: step 3 - upgrade options";
            $include = '<form action="install.php?step=upgrade4" method="post"><table width="40%" cellpadding="2" cellspacing="1" align="center" border="0">
                         <tr>
                          <td align="center" colspan="2"><b>Upgrade Options</b></td>
                         </tr>
                         <tr>
                          <td><font color="#FF0000">*</font>Update default templates?</td>
                          <td align="right"><input type="checkbox" name="upgrade_templates" value="1" checked> Yes</td>
                         </tr>
                         <tr>
                          <td><font color="#FF0000">*</font>Update default tempvars?</td>
                          <td align="right"><input type="checkbox" name="upgrade_tempvars" value="1" checked> Yes</td>
                         </tr>
                         <tr>
                          <td colspan="2" align="center"><font color="#FF0000">*</font> means highly recommended</td>
                         </tr>
                         <tr>
                          <td colspan="2" align="center"><input type="submit" value="Continue &raquo;"></td>
                         </tr>
                        </table></form>';
        break;
        case 'upgrade4':
            $location = "Update: step 4 - upgrading...";
            require('configuration/database.inc.php');
            require('configuration/config.inc.php');

            $upgrade_templates = prepValue($_POST['upgrade_templates']);
            $upgrade_tempvars = prepValue($_POST['upgrade_tempvars']);
            $upgrade_moodicons = prepValue($_POST['upgrade_moodicons']);
            $upgrade_entries = prepValue($_POST['upgrade_entries']);
            $upgrade_skins = prepValue($_POST['upgrade_skins']);

            $fp = fopen("configuration/install.sql", "rb");
            $data = fread($fp, filesize("configuration/install.sql"));
            fclose($fp);

            $tmpdata = $data;
            if(!($data = unserialize($data))){
                $data = $tmpdata;
                $data = str_replace("\n", "\\n", $data);
                $data = str_replace("\r", "\\r", $data);
                $data = unserialize($data);
            }
            $filldb = $data[0];

            $dbqueries = $data[0];
            $dbdata = $data[1];
            $newconfig = $data[2];
            $lastconfval = $data[3];

            $SQL = new MySQL($database);
            $SQL->connect();

            $bb_tables = array($database['prefix'].'active', $database['prefix'].'attachments', $database['prefix'].'boardstats', $database['prefix'].'emoticons',
                               $database['prefix'].'forums', $database['prefix'].'permissions', $database['prefix'].'pmessages', $database['prefix'].'polloptions',
                               $database['prefix'].'polls', $database['prefix'].'pollvotes', $database['prefix'].'posticons', $database['prefix'].'posts', $database['prefix'].'skins',
                               $database['prefix'].'subscriptions', $database['prefix'].'templates', $database['prefix'].'tempvars', $database['prefix'].'usergroups',
                               $database['prefix'].'topics', $database['prefix'].'userranks', $database['prefix'].'users');

            //# Update tables
            $olddata = array();
            $tableq = $SQL->query("SHOW TABLES FROM `".$database['database']."`");
            while($table = $SQL->fetch_array($tableq)){
                if(in_array($table['Tables_in_'.$database['database']], $bb_tables)){
                    $t = str_replace($database['prefix'], "bb_", $table['Tables_in_'.$database['database']]);
                    $olddbdata[$t] = array();

                    $fieldq = $SQL->query("SHOW COLUMNS FROM `".$table['Tables_in_'.$database['database']]."` FROM `".$database['database']."`");
                    while($field = $SQL->fetch_array($fieldq)){
                         $olddbdata[$t][$field['Field']] = array();
                         $olddbdata[$t][$field['Field']]['name'] = $field['Field'];
                         $olddbdata[$t][$field['Field']]['type'] = $field['Type'];
                         $olddbdata[$t][$field['Field']]['null'] = $field['Null'];
                         $olddbdata[$t][$field['Field']]['key'] = $field['Key'];
                         $olddbdata[$t][$field['Field']]['default'] = $field['Default'];
                         $olddbdata[$t][$field['Field']]['extra'] = $field['Extra'];
                    }
                }
            }

            $last = "";
            $after = "";
            foreach($dbdata as $tname => $fields){
                $table = str_replace("bb_", $database['prefix'], $tname);

                $haskey = false;
                foreach($olddbdata[$tname] as $value){
                        if(strtolower($value['key']) == "pri"){
                            $haskey = true;
                        }

                }

                $last = "";
                foreach($fields as $fname => $field){
                    if(!is_array($olddbdata[$tname][$fname])){
                        if(strtolower($field['null']) == "yes"){
                            $field['null'] = "NULL";
                        }else{
                            $field['null'] = "NOT NULL";
                        }

                        if($last != ""){
                            $after = "AFTER `$last`";
                        }else{
                            $after = "FIRST";
                        }

                        if(!$SQL->query("ALTER TABLE `$table` ADD `$fname` ".$field['type']." DEFAULT '".$field['default']."' ".$field['null']." $after", true)){
                            $check['upgrade_tables'] = '<span class="failed">Failed</span>';
                            $failcount++;
                            break;
                        }
                    }else if(($olddbdata[$tname][$fname]['type'] != $field['type']) || ($olddbdata[$tname][$fname]['null'] != $field['null']) || ($olddbdata[$tname][$fname]['default'] != $field['default'])){
                        if(strtolower($field['null']) == "yes"){
                            $field['null'] = "NULL";
                            $field['default'] = "NULL";
                        }else{
                            $field['null'] = "NOT NULL";
                            $field['default'] = "'".$field['default']."'";
                        }

                        if(!$SQL->query("ALTER TABLE `$table` CHANGE `$fname` `$fname` ".$field['type']." DEFAULT ".$field['default']." ".$field['null'], true)){
                            $check['upgrade_tables'] = '<span class="failed">Failed</span>';
                            $failcount++;
                            break;
                        }
                    }

                    if(strtolower($field['key']) == "pri" && strtolower($olddbdata[$tname][$fname]['key']) != "pri"){
                        if($haskey){
                            $key = "DROP PRIMARY KEY, ADD PRIMARY KEY(`$fname`)";
                        }else{
                            $key = "ADD PRIMARY KEY(`$fname`)";
                        }

                        if(!$SQL->query("ALTER TABLE `$table` $key", true)){
                            $check['upgrade_tables'] = '<span class="failed">Failed</span>';
                            $failcount++;
                            break;
                        }
                    }

                    if(strtolower($field['key']) != "pri" && strtolower($olddbdata[$tname][$fname]['key']) == "pri"){
                        if(!$SQL->query("ALTER TABLE `$table` DROP PRIMARY KEY", true)){
                            $check['upgrade_tables'] = '<span class="failed">Failed</span>';
                            $failcount++;
                            break;
                        }
                    }

                    if(strtolower($field['extra']) == "auto_increment" && strtolower($olddbdata[$tname][$fname]['extra']) != "auto_increment"){
                        if(!$SQL->query("ALTER TABLE `$table` CHANGE `$fname` `$fname` ".$field['type']." ".$field['null']." AUTO_INCREMENT", true)){
                            $check['upgrade_tables'] = '<span class="failed">Failed</span>';
                            $failcount++;
                            break;
                        }
                    }

                    $check['upgrade_tables'] = '<span class="passed">Success</span>';

                    $last = $fname;
                }
                if($failcount > 0){
                    break;
                }
            }

            if($upgrade_templates == 1){
                $clear = $SQL->query("DELETE FROM `".$database['prefix']."templates` WHERE `skinid`='1'");
                foreach($dbqueries['bb_templates']['queries'] as $query){
                    $query = str_replace('%prefix%', $database['prefix'], $query);

                    if(!($run = $SQL->query($query, true))){
                        $check['upgrade_templates'] = '<span class="failed">Failed</span>';
                        $failcount++;
                        break;
                    }
                    $check['upgrade_templates'] = '<span class="passed">Success</span>';
                }
            } else {
                $check['upgrade_templates'] = '<span class="skipped">Skipped</span>';
            }

            if($upgrade_tempvars == 1){
                $clear = $SQL->query("DELETE FROM `".$database['prefix']."tempvars` WHERE `skinid`='1'");
                foreach($dbqueries['bb_tempvars']['queries'] as $query){
                    $query = str_replace('%prefix%', $database['prefix'], $query);

                    if(!($run = $SQL->query($query, true))){
                        $check['upgrade_tempvars'] = '<span class="failed">Failed</span>';
                        $failcount++;
                        break;
                    }
                    $check['upgrade_tempvars'] = '<span class="passed">Success</span>';
                }
            } else {
                $check['upgrade_tempvars'] = '<span class="skipped">Skipped</span>';
            }

            //# Add any new config vars
            if(!($fp = fopen('configuration/config.inc.php', 'w'))){
                $check['config'] = '<span class="failed">Failed</span>';
                $failcount++;
            } else {
                fwrite($fp, "<?php\r\n");
                fwrite($fp, "\$config = array(\r\n");
                foreach($newconfig as $key => $value){
                    $spaces = str_repeat(" ", 17-strlen($key));

                    if(!isset($config[$key])){
                        $value = str_replace("\'", "'", $value);
                        $value = addslashes($value);
                        $value = str_replace("\n", "\\n", $value);
                        $value = str_replace("\r", "\\r", $value);

                        if(strcasecmp($key, $lastconfval) == 0){
                            if(is_numeric($value)){
                                fwrite($fp, "                \"$key\"$spaces=> $value\r\n");
                            }else{
                                fwrite($fp, "                \"$key\"$spaces=> \"$value\"\r\n");
                            }
                        }else{
                            if(is_numeric($value)){
                                fwrite($fp, "                \"$key\"$spaces=> $value,\r\n");
                            }else{
                                fwrite($fp, "                \"$key\"$spaces=> \"$value\",\r\n");
                            }
                        }
                    }else{
                        $value = str_replace("\'", "'", $config[$key]);
                        $value = addslashes($value);
                        $value = str_replace("\n", "\\n", $value);
                        $value = str_replace("\r", "\\r", $value);
                        if(strcasecmp($key, $lastconfval) == 0){
                            if(is_numeric($value)){
                                fwrite($fp, "                \"$key\"$spaces=> $value\r\n");
                            }else{
                                fwrite($fp, "                \"$key\"$spaces=> \"$value\"\r\n");
                            }
                        }else{
                            if(is_numeric($value)){
                                fwrite($fp, "                \"$key\"$spaces=> $value,\r\n");
                            }else{
                                fwrite($fp, "                \"$key\"$spaces=> \"$value\",\r\n");
                            }
                        }
                    }
                }
                fwrite($fp, ");\r\n");
                fwrite($fp, "?>");
                fclose($fp);

                $check['config'] = '<span class="passed">Success</span>';
            }

            $bottom = '<form style="display: inline;" action="install.php" method="get"><input type="submit" value="Continue &raquo;"><input type="hidden" name="step" value="complete"></form>';

            $include = '<table width="60%" align="center" border="0">
                         <tr>
                          <td><b>Update BB tables</b></td>
                          <td align="right">'.$check['upgrade_tables'].'</td>
                         </tr>
                         <tr>
                          <td><b>Update default templates</b></td>
                          <td align="right">'.$check['upgrade_templates'].'</td>
                         </tr>
                         <tr>
                          <td><b>Update default tempvars</b></td>
                          <td align="right">'.$check['upgrade_tempvars'].'</td>
                         </tr>
                         <tr>
                          <td><b>Add new config vars</b></td>
                          <td align="right">'.$check['config'].'</td>
                         </tr>
                         <tr>
                          <td align="center" colspan="2">'.$bottom.'</td>
                         </tr>
                        </table>';
        break;
        case 'complete':
            @touch('configuration/install.lock');
            $location = 'Finished';
            $include = '<center>
                       Installation complete! You can now use your board,<br>
                       <form style="display: inline;" method="get" action="index.php"><input type="submit" value="Go to board"></form><br><br>
                       </center>';
        break;
    }
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<title>BirdBoard</title>
<style type="text/css">
body {margin-top: 0px; margin-bottom: 0px; background-color: #7C95BD;}
td {font-size: 10px; font-family: verdana;}
a:link {color: #000000; text-decoration: none; font-weight:bold}
a:visited {color: #000000; text-decoration: none; font-weight:bold}
a:active {color: #000000; text-decoration: none; font-weight:bold}
a:hover {color: #6C81AA; text-decoration: underline; font-weight:bold}
input {font-family: verdana; font-size: 10px}
textarea {font-family: verdana; font-size: 10px}
select {font-family: verdana; font-size: 10px}
pre {font-family: "Lucida Sans", monospace;}
.passed {font-weight: 700; color: #008800;}
.failed {font-weight: 700; color: #FF0000;}
.skipped {font-weight: 700; color: #000000;}
.gborder {border: #000033 1px solid;}
.bborder {border: #000000 1px solid;}
.cellhead {background-image: url("images/skins/default/cellbg.gif");}
.cellhead2 {background-color: #7C95BD;}
.cellmain {background-color: #FFFFFF;}
.tablebg {background-color: #000000;}
</style>
</head>
<body>

<table cellpadding="0" cellspacing="10" class="gborder" width="750" bgcolor="#FFFFFF" align="center" height="100%">
 <tr>
  <td valign="top">
   <center><a href="index.php"><img src="images/skins/default/banner.jpg" alt="BirdBoard" class="bborder" border="0"></a></center>
   <br>
   <table cellpadding="2" cellspacing="1" align="center" width="100%" class="tablebg">
    <tr>
     <td width="100%" class="cellhead">
      <b><center><?php echo $location; ?></center></b>
     </td>
    </tr>
    <tr>
     <td width="100%" class="cellmain">
     <?php echo $include; ?>
     </td>
    </tr>
   </table><br><br>
   <?php
   if(is_object($SQL)){
       $queries = $SQL->counter();
   }else{
       $queries = 0;
   }
   echo ("<center>[ Execution Time: ".$timer->stopTimer()." ] [ Queries: $queries ] [ GZIP: Disabled ]</center>");
   ?>
   <br><br>
   <center>Powered by BirdBoard v1.0.0 <i>Beta</i>  2004</center>
  </td>
 </tr>
</table>

</body>
</html>