<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: read.php,v 1.17 2005/07/06 18:32:13 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "read");

//# Templates:
$bb_templates = '1,12,21,22,23,24,25,26,30,31,32,33,41,60,65,67,79,80,145';
require("core.php");

//# Setting topic ID
$tid = prepValue($_GET['tid']);
if ($tid == "" || !is_numeric($tid)) {
    $tid = 1;
}
$tid = round($tid);

//# Other actions for reading
$a = prepvalue($_GET['a']);
if ($a == "downloadattachment") {
    $attachid = $_GET['attachid'];

    //# Query attachment
    $grabattachment = $SQL->query("SELECT * FROM `".$database['prefix']."attachments` WHERE `id`='$attachid'");
    $attachment = $SQL->fetch_array($grabattachment);

    //# Update downloads
    $updatedownloads = $SQL->query("UPDATE `".$database['prefix']."attachments` SET `downloads` = downloads + 1 WHERE `id` = $attachid");

    //# Output headers
    header("Expires: ".gmdate("D, d M Y H:i:s", time()+60)." GMT");
    header("Last-Modified: ".gmdate("D, d M Y H:i:s", $attachment['date'])." GMT");
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Cache-Control: post-check=0, pre-check=0", false);
    header("Pragma: no-cache");
    header("Content-Type: application/octet-stream");
    header("Content-Disposition: attachment; filename=".$attachment['name']);
    header("Content-Length: ".$attachment['size']);

    //# Output file content
    echo $attachment['content'];

    //# Parse and print
    $gzip->stopGZ();
    die();
} else if ($a == "lastpost") { //goes to last post
    $lastpageq = $SQL->query("SELECT `id` FROM `".$database['prefix']."posts` WHERE `tid`='$tid' ORDER BY `id` DESC");
    $lastpage = $SQL->num_rows($lastpageq);
    if ($lastpage <= 0) {
        $lastpage = 1;
    } else {
        $lastpage = ceil($lastpage / $user->getData('postsperpage'));
    }
    $lastpost = $SQL->fetch_array($lastpageq);
    $_GET['page'] = $lastpage;
    $url = "read.php?tid=".$tid."&page=".$lastpage."#postid:".$lastpost['id'];
    die_header("Location: ".$config['boardurl'].$url);
} else if ($a == "specificpost") { //goes to a specified post
    $pid = prepvalue($_GET['pid']);
    if ($pid == "" || !is_numeric($pid)) {
        $pid = 1;
    }
    $pid = round($pid);
    $postsq = $SQL->query("SELECT `id` FROM `".$database['prefix']."posts` WHERE `tid`='$tid' AND `id`<='$pid'");
    $posts = $SQL->num_rows($postsq);
    $page = ceil($posts / $user->getData('postsperpage'));

    $url = "read.php?tid=".$tid."&page=".$page."#postid:".$pid;
    die_header("Location: ".$config['boardurl'].$url);
} else if ($a == "gototime") { //goes to a post based on a specified time
    $time = prepValue($_GET['time']);
    if($time == "" || !is_numeric($time)){
        $url = "read.php?tid=".$tid."&a=lastpost";
        die_header("Location: ".$config['boardurl'].$url);
    }
    $time = round($time);
    $closestq = $SQL->query("SELECT `id` FROM `".$database['prefix']."posts` WHERE `tid`='$tid' AND `dateline`<='$time' ORDER BY `dateline` DESC LIMIT 1");
    if ($SQL->num_rows($closestq)<=0) {
        $url = "read.php?tid=".$tid."&a=lastpost";
        die_header("Location: ".$config['boardurl'].$url);
    }
    $closest = $SQL->fetch_array($closestq);
    $postsq = $SQL->query("SELECT `id` FROM `".$database['prefix']."posts` WHERE `tid`='$tid' AND `id`<='".$closest['id']."'");
    $posts = $SQL->num_rows($postsq);
    $page = ceil($posts / $user->getData('postsperpage'));

    $url = "read.php?tid=".$tid."&page=".$page."#postid:".$closest['id'];
    die_header("Location: ".$config['boardurl'].$url);
}

//# Grabbing topic data, forum data, and category data
$dataquery = $SQL->query("SELECT t.title,t.authorid,t.authorname,t.replies,t.locked, t.sticky,
                            f.id,f.name,f.class,c.id AS cid,c.name AS cname
                            FROM `".$database['prefix']."topics` AS t LEFT JOIN
                            `".$database['prefix']."forums` AS f ON (f.id = t.fid) LEFT JOIN
                            `".$database['prefix']."forums` AS c ON(f.parent = c.id) WHERE t.id='".$tid."'");
$data = $SQL->fetch_array($dataquery);

//# Filling arrays with appropriate data
$topic['id'] = $tid;
$topic['authorid'] = $data['authorid'];
$topic['authorname'] = $data['authorname'];
$topic['title'] = $data['title'];
$topic['replies'] = $data['replies'];
$topic['locked'] = $data['locked'];
$topic['sticky'] = $data['sticky'];
$forum['id'] = $data['id'];
$forum['name'] = $data['name'];
$forum['class'] = $data['class'];
$forum['cid'] = $data['cid'];
$forum['cname'] = $data['cname'];

//# Grabbing forum permissions
$user->setForumPerms($forum['id']);

//# Breadcrumbs
if($forum['class'] == "subforum"){
    $forumq = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname,p.id AS pid, p.name AS pname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS p ON(p.id=f.parent) LEFT JOIN `".$database['prefix']."forums` AS c ON(p.parent = c.id) WHERE f.id='$forum[id]'");
    $forum = $SQL->fetch_array($forumq);
    $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$forum[cid]\">$forum[cname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$forum[pid]\">$forum[pname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$forum[id]\">$forum[name]</a>" . $template->getVar('crumbsseperator') . "$topic[title]";
} else {
    $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$forum[cid]\">$forum[cname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$forum[id]\">$forum[name]</a>" . $template->getVar('crumbsseperator') . "$topic[title]";
}

if($user->getData('view_topic') != 1){
    bb_error("You are not allowed to view this topic.");
}

//# Updating read/unread topics
$time = time();
$unreadtopics = unserialize($_SESSION['bbunreadtopics']);
$searchunread = $SQL->query("SELECT `id`, `fid`, `lpdate`, `lpuserid` FROM `".$database['prefix']."topics` WHERE `fid` = '".$forum['id']."' AND `lpdate` > ".$user->getForumData($forum['id']));
while($unread = $SQL->fetch_array($searchunread)){
    if($unread['lpuserid'] != $user->getData('id') || ($unread['lpuserid'] == $user->getData('id') && $user->getData('id') == 0)){
       $unreadtopics[$unread['fid']][$unread['id']] = $time;
    }
}
$unreadtopics[$forum['id']][$topic['id']] = 0;
$_SESSION['bbunreadtopics'] = serialize($unreadtopics);
$user->setForumData($forum['id'], time());

//# Updating post views
$views = $SQL->query("UPDATE `".$database['prefix']."topics` SET `views` = views + 1 WHERE `id`='".$topic['id']."'");

//# Checking for polls
$grabpoll = $SQL->query("SELECT p.id AS pid, p.tid, p.title,p.multichoice, p.totalvotes,o.* FROM `".$database['prefix']."polls` AS p LEFT JOIN `".$database['prefix']."polloptions` AS o ON (p.id = o.pollid) WHERE p.tid = '".$topic['id']."'");
$checkpoll = $SQL->num_rows($grabpoll);
if($checkpoll > 0){
    while($choice = $SQL->fetch_array($grabpoll)){
        $data = $choice;
        $choice['displayname'] = $choice['name'];
        if($choice['multichoice'] == 1){
            $choice['checktype'] = "checkbox";
            $choice['name'] = $choice['id'];
            $choice['value'] = 1;
        } else {
            $choice['checktype'] = "radio";
            $choice['name'] = "option";
            $choice['value'] = $choice['id'];
        }
        $choice['percent'] = (!empty($choice['totalvotes']) && $choice['totalvotes'] != 0) ? round($choice['votes'] / ($choice['totalvotes'] / 100), 2) : 0;
        $choice['imgpercent'] = $choice['percent'];
        if ($choice['imgpercent'] > 98) {
            $choice['imgpercent'] -= 2;
        }
        $poll['choices'] .= $template->templates['31'];
        $poll['choices'] = stripslashes($poll['choices']);
        $poll['choices'] = $template->cacheArray($poll['choices'], $choice);
    }
    $choice = $template->releaseCache();
    eval("\$poll['choices'] = \"".addslashes($poll['choices'])."\";");
    $poll['id'] = $data['pid'];
    $poll['title'] = $data['title'];
    $poll['multichoice'] = $data['multichoice'];
    $grabuservote = $SQL->query("SELECT * FROM `".$database['prefix']."pollvotes` WHERE `pollid` = '".$poll['id']."' AND `uid` = '".$user->getData('id')."'");
    if($SQL->num_rows($grabuservote) > 0){
        $poll['submitarea'] = $template->templates['33'];
    } else {
        $poll['submitarea'] = $template->templates['32'];
    }
    eval("\$pollarea = \"".$template->templates['30']."\";");
} else {
    $pollarea = "";
}

//# Grabbing emoticons
$grabemoticons = $SQL->query("SELECT `id`,`emoticon`,`image` FROM `".$database['prefix']."emoticons`");
while($grab = $SQL->fetch_array($grabemoticons)){
    $emoticons[$grab['id']] = $grab['emoticon'];
    $emoticonimages[$grab['id']] = "<img src=\"$config[emoticonpath]$grab[image]\" alt=\"$grab[emoticon]\" />";
}


//# Deciding which posts to grab
$page = prepValue($_GET['page']);
if ($page == "" || !is_numeric($page)) {
    $page = 1;
}
$page = round($page);
$start = ($page * $user->getData('postsperpage')) - $user->getData('postsperpage');
$lastpage = $topic['replies'] + 1;
if ($lastpage <= 0) {
    $lastpage = 1;
} else {
    $lastpage = ceil($lastpage / $user->getData('postsperpage'));
}
if ($page > $lastpage) {
    die_header("Location: ".$config['boardurl']."read.php?tid=$tid&page=$lastpage");
}
if ($page < 1) {
    die_header("Location: ".$config['boardurl']."read.php?tid=$tid&page=1");
}
$pagevars = array();
$pagevars['totalpages'] = $lastpage;
$pagevars['first'] = "";
$pagevars['middle'] = "";
$pagevars['last'] = "";
if(($page - 3) >= 2){
    $pagevars['first'] = "<a href=\"read.php?tid=$tid&page=1\">".$template->getVar('firstpagetext')."</a> ... ";
    for($i = $page - 3; $i < $page; $i++){
        $pagevars['middle'] .= "<a href=\"read.php?tid=$tid&page=$i\">$i</a>, ";
    }
} else {
    for($i = 1; $i < $page; $i++){
        $pagevars['middle'] .= "<a href=\"read.php?tid=$tid&page=$i\">$i</a>, ";
    }
}
$pagevars['middle'] .= $page;
if(($page + 3) < $pagevars['totalpages']){
    $pagevars['last'] = " ... <a href=\"read.php?tid=$tid&page=$pagevars[totalpages]\">".$template->getVar('lastpagetext')."</a>";
    for($i = $page + 1; $i < $page + 4; $i++){
        $pagevars['middle'] .= ", <a href=\"read.php?tid=$tid&page=$i\">$i</a>";
    }
} else {
    for($i = $page + 1; $i <= $pagevars['totalpages']; $i++){
        $pagevars['middle'] .= ", <a href=\"read.php?tid=$tid&page=$i\">$i</a>";
    }
}
$choosepage = $pagevars['first'] . $pagevars['middle'] . $pagevars['last'];
if($pagevars['totalpages'] < 2){
    $choosepage = "";
}

if($config['remembertopicloc'] == 1){
    $user->setLastTopicView($topic['id'], time());
}

//# Grabbing posts
$grabposts = $SQL->query("SELECT u.username,u.avatar,u.title AS usertitle,
                          u.location,u.pageurl,u.aim,
                          u.icq,u.msn,u.yim,u.signature,
                          u.joindate,u.posts,p.id,p.postername,p.posterid,
                          p.iconid,p.title,p.message,p.dateline,p.ip,p.parseurls,
                          p.disableemoticons,p.disablesiggy,p.attachmentid,p.editname,p.editdate, i.value AS posticon,
                          a.name AS attachmentname,a.size AS attachmentsize,a.downloads AS attachmentdownloads,
                          r.title AS ranktitle, r.image AS rankimage,
                          g.style AS userstyle
                          FROM `".$database['prefix']."users` AS u
                          RIGHT JOIN `".$database['prefix']."posts` AS p ON(u.id=p.posterid)
                          LEFT JOIN `".$database['prefix']."posticons` AS i ON (i.id = p.iconid)
                          LEFT JOIN `".$database['prefix']."attachments` AS a ON(p.attachmentid=a.id)
                          LEFT JOIN `".$database['prefix']."userranks` AS r ON(r.gid = u.gid AND r.minposts <= u.posts AND r.maxposts >= u.posts)
                          LEFT JOIN `".$database['prefix']."usergroups` AS g ON (g.id = u.gid)
                          WHERE p.tid='".$topic['id']."' ORDER BY p.id ASC LIMIT $start, ".$user->getData('postsperpage')."");
if($SQL->num_rows($grabposts) < 1){
    bb_error("Topic doesn't exist.");
}
while($post = $SQL->fetch_array($grabposts)){
    if($post['posterid'] != 0){
        $posts .= $template->templates['22'];
    } else {
        $posts .= $template->templates['24'];
    }
    if($post['usertitle'] == ""){
        $post['usertitle'] = $post['ranktitle'];
    }
    if($post['aim'] != ""){
        $post['aimbutton'] = "<a href=\"aim:goim?screenname=".$post['aim']."&amp;message=Greetings\" title=\"".$post['aim']."\"><img src=\"".$template->getVar('imagepath')."/".$template->getVar('aimbutton')."\" border=\"0\"></a>";
    }
    if($post['icq'] != ""){
        $post['icqbutton'] = "<a href=\"http://msg.mirabilis.com/scripts/WWPMsg.dll?from=".$user->getData('username')."&fromemail=".$user->getData('email')."&body=Greetings&subject=Hi&to=".$post['icq']."\" title=\"".$post['icq']."\" target=\"_blank\"><img src=\"".$template->getVar('imagepath')."/".$template->getVar('icqbutton')."\" border=\"0\"></a>";
    }
    if($post['msn'] != ""){
        $post['msnbutton'] = "<a href=\"member.php?a=viewprof&uid=".$post['posterid']."\" title=\"".$post['msn']."\"><img src=\"".$template->getVar('imagepath')."/".$template->getVar('msnbutton')."\" border=\"0\"></a>";
    }
    if($post['yim'] != ""){
        $post['yimbutton'] = "<a href=\"http://edit.yahoo.com/config/send_webmesg?.target=".$post['yim']."&.amp;src=pg\" title=\"".$post['yim']."\" target=\"_blank\"><img src=\"".$template->getVar('imagepath')."/".$template->getVar('yimbutton')."\" border=\"0\"></a>";
    }
    if($post['pageurl'] != ""){
        $post['wwwbutton'] = "<a href=\"".$post['pageurl']."\" title=\"".$post['pageurl']."\"><img src=\"".$template->getVar('imagepath')."/".$template->getVar('wwwbutton')."\" border=\"0\"></a>";
    }
    $post['pm'] = "<a href=\"usercp.php?a=outbox&postid=".$post['id']."\"><img src=\"".$template->getVar('imagepath')."/".$template->getVar('pmbutton')."\" border=\"0\"></a>";
    if(($post['title'] != "") || ($post['posticon'] != "")){
        $post['title'] = addslashes(addslashes(addslashes($post['title'])));
        if($post['posticon'] != ""){
            $post['icon'] = "<img src=\"$config[posticonpath]".$post['posticon']."\" alt=\"\" />";
        }
        $posts = str_replace('$post[iconsubject]', $template->templates['23'], $posts);
    } else {
        $posts = str_replace('$post[iconsubject]', '', $posts);
    }
    if(($post['avatar'] != "") && ($user->getData('viewavatars') != 0)){
        if(strtolower(substr($post['avatar'], 0, 7)) != "http://"){
            $post['avatar'] = $config['avatarpath'] . $post['avatar'];
        }
        $post['avatar'] = "<img src=\"".$post['avatar']."\" alt=\"".$post['postername']."'s Avatar\" />";
    } else {
        $post['avatar'] = "";
    }
    $post['rankimage'] = $template->getVar('imagepath') . $post['rankimage'];
    $post['location'] = stripslashes($post['location']);
    $post['joined'] = date($template->getVar('joindateformat'), $post['joindate']);
    $post['date'] = gmdate($template->getVar('postdateformat'), $post['dateline'] + ($user->getData('offset') * 3600));
    //attachments
    if($post['attachmentid'] != 0){
        $posts = str_replace('$post[attachmentarea]', stripslashes($template->templates['26']), $posts);
    } else {
        $posts = str_replace('$post[attachmentarea]', '', $posts);
    }
    //prepping message for output
    $post['message'] = addslashes(addslashes(addslashes($post['message'])));

    //censoring words
    if($user->getData('censor') == 1){
        $post['message'] = censor($post['message']);
    }
    //parsing emoticons in post
    if($post['disableemoticons'] == 0){
        $post['message'] = parse_emoticons($post['message'], $emoticons, $emoticonimages, $config['emoticonsperpost']);
    }
    //calling the function to parse bbcode
    $post['message'] = parse_breaks($post['message']);
    $post['message'] = parse_bbcode($post['message']);

    //parsing slash replacements
    $post['message'] = str_replace("/me","<font color='#DD0000'>".$post['username']."</font>",$post['message']);
    $post['message'] = str_replace("/maim","<font color='#DD0000'>".$post['aim']."</font>",$post['message']);
    $post['message'] = str_replace("/mmsn","<font color='#DD0000'>".$post['msn']."</font>",$post['message']);
    $post['message'] = str_replace("/micq","<font color='#DD0000'>".$post['icq']."</font>",$post['message']);
    $post['message'] = str_replace("/myim","<font color='#DD0000'>".$post['yim']."</font>",$post['message']);
    $post['message'] = str_replace("/you","<font color='#007700'>".$user->getData('username')."</font>",$post['message']);
    $post['message'] = str_replace("/ygroup","<font color='#007700'>".$user->getData('name')."</font>",$post['message']);
    $post['message'] = str_replace("/ybday","<font color='#007700'>".$user->getData('bday').".".$user->getData('bmonth').".".$user->getData('byear')."</font>",$post['message']);

    //autoparsing urls in post
    if($post['parseurls'] == 1){
        $post['message'] = parse_urls($post['message']);
    }
    //checking for edits
    if ($post['editname'] != "") {
        $post['editdate'] = gmdate($template->getVar('postdateformat'), $post['editdate'] + ($user->getData('offset') * 3600));
        $post['message'] .= "<br><br><i>** Last Edited by ".$post['editname']." on ".$post['editdate']." **</i>";
    }

    //setting/unsetting signature per user settings
    if(($user->getData('viewsiggies') == 1) && ($post['disablesiggy'] == 0) && ($post['signature'] != "")){
        $post['signature'] = addslashes(addslashes(addslashes($post['signature'])));
        if($user->getData('censor') == 1){
            $post['signature'] = censor($post['signature']);
        }
        $post['signature'] = parse_breaks($post['signature']);
        $post['signature'] = parse_bbcode($post['signature']);
        $posts = str_replace('$post[signaturearea]', $template->templates['41'], $posts);
    } else {
        $posts = str_replace('$post[signaturearea]', '', $posts);
    }
    $posts = $template->cacheArray($posts, $post);
}
$post = $template->releaseCache();
eval("\$posts = \"$posts\";");
$posts = stripslashes(stripslashes($posts));

//# Topic options menu
if(($user->getData('delete_own') == 1 && $topic['authorid'] == $user->getData('id')) || ($user->getData('delete_others') == 1 && $topic['authorid'] != $user->getData('id')) || $user->getData('lock_topics') == 1 || $user->getData('stick_topics') == 1 || $user->getData('move_topics') == 1){
    $menuoptions = array();
    if(($user->getData('delete_own') == 1 && $topic['authorid'] == $user->getData('id')) || ($user->getData('delete_others') == 1 && $topic['authorid'] != $user->getData('id'))){
        $menuoptions['label'] = "Delete Topic";
        $menuoptions['action'] = "deletetopic";
        $menuoptionsarea .= stripslashes($template->templates['80']);
        $menuoptionsarea = $template->cacheArray($menuoptionsarea, $menuoptions);
    }
    if($user->getData('lock_topics') == 1){
        if($topic['locked'] == 1){
            $menuoptions['label'] = "Unlock Topic";
            $menuoptions['action'] = "unlocktopic";
        } else {
            $menuoptions['label'] = "Lock Topic";
            $menuoptions['action'] = "locktopic";
        }
        $menuoptionsarea .= stripslashes($template->templates['80']);
        $menuoptionsarea = $template->cacheArray($menuoptionsarea, $menuoptions);
    }
    if($user->getData('stick_topics') == 1){
        if($topic['sticky'] == 1){
            $menuoptions['label'] = "Unstick Topic";
            $menuoptions['action'] = "unstickytopic";
        } else {
            $menuoptions['label'] = "Stick Topic";
            $menuoptions['action'] = "stickytopic";
        }
        $menuoptionsarea .= stripslashes($template->templates['80']);
        $menuoptionsarea = $template->cacheArray($menuoptionsarea, $menuoptions);
    }
    if($user->getData('move_topics') == 1){
        $menuoptions['label'] = "Move Topic";
        $menuoptions['action'] = "movetopicform";
        $menuoptionsarea .= stripslashes($template->templates['80']);
        $menuoptionsarea = $template->cacheArray($menuoptionsarea, $menuoptions);
    }
    $menuoptions = $template->releaseCache();
    eval("\$menuoptionsarea = \"".addslashes($menuoptionsarea)."\";");
    eval("\$topicmenu = \"".$template->templates['79']."\";");
}

eval("\$include = \"".$template->templates['21']."\";");

//# Updating active table
$user->updateActive("Viewing Topic: <a href=\"read.php?tid=$topic[id]\">$topic[title]</a>");

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>